package ru.dbotthepony.mc.otm.capability.android;

import net.minecraft.network.FriendlyByteBuf;
import net.minecraftforge.registries.*;

public class AndroidFeatureType<T extends AndroidFeature> extends ForgeRegistryEntry<AndroidFeatureType<?>> {
	public interface AndroidFeatureFactory<T extends AndroidFeature> {
		T factory(AndroidFeatureType<T> entry, IAndroidCapability capability);
	}

	protected final AndroidFeatureFactory<T> factory;

	public AndroidFeatureType(AndroidFeatureFactory<T> factory) {
		this.factory = factory;
	}

	public T factory(IAndroidCapability capability) {
		return factory.factory(this, capability);
	}

	public boolean isApplicable(IAndroidCapability capability) {
		return true;
	}
}
