package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.inventory.MenuType;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatteryPowered;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.menu.slot.BatterySlot;
import ru.dbotthepony.mc.otm.menu.widget.BatteryLevelWidget;

import javax.annotation.Nullable;

abstract public class PoweredMatteryMenu extends MatteryMenu {
	protected BlockEntityMatteryPowered tile;

	public BatteryLevelWidget<PoweredMatteryMenu> battery_widget;

	protected PoweredMatteryMenu(
			@Nullable MenuType<?> menuType,
			int containerID,
			Inventory inventory,
			@Nullable BlockEntityMatteryPowered tile
	) {
		super(menuType, containerID, inventory, tile);
		this.tile = tile;

		if (tile == null || tile.getCapability(MatteryCapability.ENERGY).resolve().isEmpty()) {
			battery_widget = new BatteryLevelWidget<>(this, 13, 14);
		} else {
			battery_widget = new BatteryLevelWidget<>(this, 13, 14, tile.getCapability(MatteryCapability.ENERGY).resolve().get());
		}
	}

	protected void addBatterySlot() {
		addBatterySlot(10, 66);
	}

	protected void addBatterySlot(int x) {
		addBatterySlot(x, 66);
	}

	protected void addBatterySlot(int x, int y) {
		Container battery_container = tile != null ? tile.battery_container : new SimpleContainer(1);
		this.addSlot(new BatterySlot(battery_container, 0, x, y, true));
	}
}
