package ru.dbotthepony.mc.otm.menu.slot;

import net.minecraft.world.Container;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.ItemStack;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.container.MatteryContainer;

// Just a sign that this slot needs auto draw
public class MatterySlot extends Slot {
	public boolean auto_bg;

	public MatterySlot(Container p_40223_, int index, int x, int y, boolean auto_bg) {
		super(p_40223_, index, x, y);
		this.auto_bg = auto_bg;
	}

	public MatterySlot(Container p_40223_, int index, int x, int y) {
		this(p_40223_, index, x, y, true);
	}

	private ItemStack last_stack;
	private ItemStack watching_stack;

	public void watchCurrentStack() {
		watching_stack = super.getItem().copy();
	}

	public void unwatchCurrentStack() {
		watching_stack = null;
	}

	@Override
	public ItemStack getItem() {
		var get = super.getItem();
		last_stack = get.copy();
		return get;
	}

	@Override
	public void setChanged() {
		if (container instanceof MatteryContainer container1) {
			ItemStack old = watching_stack != null ? watching_stack.copy() : last_stack.copy();
			container1.setChanged(getSlotIndex(), super.getItem(), old);
		} else {
			super.setChanged();
		}
	}

	@Override
	public void set(ItemStack p_40240_) {
		if (container instanceof MatteryContainer container1) {
			ItemStack old = watching_stack != null ? watching_stack.copy() : container1.getItem(getSlotIndex()).copy();
			container1.startIgnore();
			container1.setItem(getSlotIndex(), p_40240_);
			container1.stopIgnore();
			container1.setChanged(getSlotIndex(), p_40240_, old);
		} else {
			super.set(p_40240_);
		}
	}

	@Override
	public void onTake(Player p_150645_, ItemStack p_150646_) {
		if (container instanceof MatteryContainer container1) {
			ItemStack old = watching_stack != null ? watching_stack.copy() : last_stack.copy();
			container1.setChanged(getSlotIndex(), p_150646_.copy(), old);
			last_stack = ItemStack.EMPTY;
		} else {
			super.onTake(p_150645_, p_150646_);
		}
	}
}
