package ru.dbotthepony.mc.otm.network;

import net.minecraft.resources.ResourceLocation;
import net.minecraftforge.fmllegacy.network.NetworkDirection;
import net.minecraftforge.fmllegacy.network.NetworkRegistry;
import net.minecraftforge.fmllegacy.network.simple.SimpleChannel;
import ru.dbotthepony.mc.otm.OverdriveThatMatters;
import ru.dbotthepony.mc.otm.network.android.AndroidBatteryPacket;
import ru.dbotthepony.mc.otm.network.android.AndroidEnergyPacket;
import ru.dbotthepony.mc.otm.network.android.AndroidFeaturePacket;
import ru.dbotthepony.mc.otm.network.android.AndroidStatusPacket;

import java.util.Optional;

public class MatteryNetworking {
	private static final String PROTOCOL_VERSION = "2";

	private static int next_network_id = 0;

	public static final SimpleChannel CHANNEL = NetworkRegistry.newSimpleChannel(
		new ResourceLocation(OverdriveThatMatters.MOD_ID, "main"),
		() -> PROTOCOL_VERSION,
		PROTOCOL_VERSION::equals,
		PROTOCOL_VERSION::equals
	);

	public static void register() {
		CHANNEL.registerMessage(
			next_network_id++,
			AndroidBatteryPacket.class,
			AndroidBatteryPacket::write,
			AndroidBatteryPacket::read,
			AndroidBatteryPacket::play,
			Optional.of(NetworkDirection.PLAY_TO_CLIENT)
		);

		CHANNEL.registerMessage(
			next_network_id++,
			AndroidEnergyPacket.class,
			AndroidEnergyPacket::write,
			AndroidEnergyPacket::read,
			AndroidEnergyPacket::play,
			Optional.of(NetworkDirection.PLAY_TO_CLIENT)
		);

		CHANNEL.registerMessage(
			next_network_id++,
			AndroidStatusPacket.class,
			AndroidStatusPacket::write,
			AndroidStatusPacket::read,
			AndroidStatusPacket::play,
			Optional.of(NetworkDirection.PLAY_TO_CLIENT)
		);

		CHANNEL.registerMessage(
			next_network_id++,
			AndroidFeaturePacket.class,
			AndroidFeaturePacket::write,
			AndroidFeaturePacket::read,
			AndroidFeaturePacket::play,
			Optional.of(NetworkDirection.PLAY_TO_CLIENT)
		);

		CHANNEL.registerMessage(
			next_network_id++,
			PatternGridPacket.class,
			PatternGridPacket::write,
			PatternGridPacket::read,
			PatternGridPacket::play,
			Optional.of(NetworkDirection.PLAY_TO_CLIENT)
		);

		CHANNEL.registerMessage(
			next_network_id++,
			MatterTaskPacket.class,
			MatterTaskPacket::write,
			MatterTaskPacket::read,
			MatterTaskPacket::play,
			Optional.of(NetworkDirection.PLAY_TO_CLIENT)
		);

		CHANNEL.registerMessage(
			next_network_id++,
			CancelMatterTaskPacket.class,
			CancelMatterTaskPacket::write,
			CancelMatterTaskPacket::read,
			CancelMatterTaskPacket::play,
			Optional.of(NetworkDirection.PLAY_TO_SERVER)
		);

		CHANNEL.registerMessage(
			next_network_id++,
			PatternReplicationRequestPacket.class,
			PatternReplicationRequestPacket::write,
			PatternReplicationRequestPacket::read,
			PatternReplicationRequestPacket::play,
			Optional.of(NetworkDirection.PLAY_TO_SERVER)
		);

		CHANNEL.registerMessage(
			next_network_id++,
			MatterRegistryPacket.class,
			MatterRegistryPacket::write,
			MatterRegistryPacket::read,
			MatterRegistryPacket::play,
			Optional.of(NetworkDirection.PLAY_TO_CLIENT)
		);
	}
}
